<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <vitaly.hohlov@gmail.com>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Блок "Выборка по тегам".
 *
 * <a href="http://wiki.a-cms.ru/blocks/bytags">Руководство</a>.
 */

class bytags_Block extends A_Block
{
/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
	$idsec=array();
	if(!empty($this->params['idsections']))
	foreach($this->params['idsections'] as $id)
	$idsec[]=(integer)$id;

	$items=array();

	if(!empty($this->params['tags']))
	{
	  $tags=array();
	  if(is_array($this->params['tags']))
      { foreach($this->params['tags'] as $i=>$_tag)
        $tags[]=$_tag['name'];
      }
	  else
	  $tags=explode(",",$this->params['tags']);

      $idtags=array();
	  foreach($tags as $tag)
	  if($idtag=A::$DB->getOne("SELECT id FROM {$this->section}_tags WHERE tag=?",mb_strtolower(trim($tag))))
	  $idtags[]=sprintf("%04d",$idtag);
	  $idtags=array_unique($idtags);
	  $idtags=implode(" ",$idtags);

	  $rows=!empty($this->params['rows'])?(integer)$this->params['rows']:0;

	  switch($this->params['sort'])
	  { default:
	    case 1: $sort="date DESC"; break;
	    case 2: $sort="date"; break;
	    case 3: $sort="name"; break;
	    case 4: $sort="RAND()"; break;
	  }

	  if($idtags)
	  {
	    $where=array();
	    if(!empty($idsec))
	    $where[]="idsec IN(".implode(",",$idsec).")";
	    if(!empty(A::$MAINFRAME->iditem))
	    $where[]="iditem<>".(integer)A::$MAINFRAME->iditem;
	    $where[]="MATCH(`idtags`) AGAINST ('{$idtags}' IN BOOLEAN MODE)";
	    $where=implode(" AND ",$where);

		if($rows)
	    A::$DB->queryLimit("SELECT `date`,`idsec`,`iditem`,`idtags` FROM {$this->section} WHERE {$where} ORDER BY {$sort}",0,$rows);
		else
		A::$DB->query("SELECT `date`,`idsec`,`iditem`,`idtags` FROM {$this->section} WHERE {$where} ORDER BY {$sort}");

	    while($row=A::$DB->fetchRow())
	    { $item=array();
	      $section=getSectionById($row['idsec']);
	      $module=getModuleBySection($section);
	      if(function_exists($module.'_getItem'))
	      { $item=call_user_func($module.'_getItem',$row['iditem'],$section,$row['idsec']);
	        $item['section']=$section;
	        $item['module']=$module;
	        $items[]=$item;
	      }
	    }
		A::$DB->free();
	  }
	}

	$this->Assign("items",$items);
  }
}