<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <vitaly.hohlov@gmail.com>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Серверная сторона AJAX настройки блока "Выборка по тегам".
 *
 * <a href="http://wiki.a-cms.ru/blocks/bytags">Руководство</a>.
 */

class bytags_BlockRequest extends A_Request
{
/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
    { case "add": $this->Add(); break;
	  case "edit": $this->Edit(); break;
	}
  }

/**
 * Обработчик действия: Отдает форму добавления.
 */

  function Add()
  {
	$form = new A_Form("block_bytags_add.tpl");
	$form->data['idsec']=A::$DB->getOne("SELECT id FROM ".DOMAIN."_sections WHERE module='search'");
	$form->data['sections']=A_SearchEngine::getInstance()->getSections();
	foreach($form->data['sections'] as $id=>$name)
	{ $section=getSectionById($id);
	  if(!getOption($section,'usetags'))
	  unset($form->data['sections'][$id]);
	}
	$this->RESULT['html']=$form->getContent();
  }

/**
 * Обработчик действия: Отдает форму редактирования.
 */

  function Edit()
  {
	$form = new A_Form("block_bytags_edit.tpl");
	$block=A::$DB->getRowById($_POST['id'],DOMAIN."_blocks");
	$form->data=!empty($block['params'])?unserialize($block['params']):array();
	$form->data['idsec']=A::$DB->getOne("SELECT id FROM ".DOMAIN."_sections WHERE module='search'");
	$form->data['sections']=A_SearchEngine::getInstance()->getSections();
	foreach($form->data['sections'] as $id=>$name)
	{ $section=getSectionById($id);
	  if(!getOption($section,'usetags'))
	  unset($form->data['sections'][$id]);
	}

	$this->RESULT['html']=$form->getContent();
  }
}

A::$REQUEST = new bytags_BlockRequest;